/* ###################################################################
**     Filename    : main.c
**     Project     : CAN_LDD
**     Processor   : MK60FN1M0VLQ12
**     Version     : Driver 01.01
**     Compiler    : GNU C Compiler
**     Date/Time   : 2017-09-28, 11:16, # CodeGen: 0
**     Abstract    :
**         Main module.
**         This module contains user's application code.
**     Settings    :
**     Contents    :
**         No public methods
**
** ###################################################################*/
/*!
** @file main.c
** @version 01.01
** @brief
**         Main module.
**         This module contains user's application code.
*/         
/*!
**  @addtogroup main_module main module documentation
**  @{
*/         
/* MODULE main */


/* Including needed modules to compile this module/procedure */
#include "Cpu.h"
#include "Events.h"
#include "CAN1.h"
/* Including shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"

/* User includes (#include below this line is not maintained by Processor Expert) */
volatile bool DataFrameTxFlg;
LDD_TDeviceData *MyCANPtr;
LDD_TError Error;
LDD_CAN_TFrame Frame;
uint8_t OutData[4] = {0x00U, 0x01U, 0x02U, 0x03U};                /* Initialization of output data buffer */


/*lint -save  -e970 Disable MISRA rule (6.3) checking. */
int main(void)
/*lint -restore Enable MISRA rule (6.3) checking. */
{
  /* Write your local variable definition here */

  /*** Processor Expert internal initialization. DON'T REMOVE THIS CODE!!! ***/
  PE_low_level_init();
  /*** End of Processor Expert internal initialization.                    ***/

  /* Write your code here */
  /* For example: for(;;) { } */
  MyCANPtr = CAN1_Init(NULL);                                     /* Initialization of CAN2 component */  
  
  Frame.MessageID = 0x123U;                                       /* Set Tx ID value - standard */  
  Frame.FrameType = LDD_CAN_DATA_FRAME;                           /* Specyfying type of Tx frame - Data frame */
  Frame.Length = sizeof(OutData);                                 /* Set number of bytes in data frame - 4B */
  Frame.Data = OutData;                                           /* Set pointer to OutData buffer */
  DataFrameTxFlg = FALSE;                                         /* Initialization of DataFrameTxFlg */
  Error = CAN1_SendFrame(MyCANPtr, 0U, &Frame);                   /* Sends the data frame over buffer 0 */ 
  while (!DataFrameTxFlg) {                                       /* Wait until data frame is transmitted */
  }

  Frame.MessageID = (0x123456U | LDD_CAN_MESSAGE_ID_EXT);         /* Set Tx ID value - extended */  
  Frame.FrameType = LDD_CAN_DATA_FRAME;                           /* Specyfying type of Tx frame - Data frame */
  Frame.Length = sizeof(OutData);                                 /* Set number of bytes in data frame - 4B */
  Frame.Data = OutData;                                           /* Set pointer to OutData buffer */
  DataFrameTxFlg = FALSE;                                         /* Clear DataFrameTxFlg */
  Error = CAN1_SendFrame(MyCANPtr, 0U, &Frame);                   /* Sends the data frame over buffer 0 */ 
  while (!DataFrameTxFlg) {                                       /* Wait until data frame is transmitted */
  }
  
  for(;;) {}

  /*** Don't write any code pass this line, or it will be deleted during code generation. ***/
  /*** RTOS startup code. Macro PEX_RTOS_START is defined by the RTOS component. DON'T MODIFY THIS CODE!!! ***/
  #ifdef PEX_RTOS_START
    PEX_RTOS_START();                  /* Startup of the selected RTOS. Macro is defined by the RTOS component. */
  #endif
  /*** End of RTOS startup code.  ***/
  /*** Processor Expert end of main routine. DON'T MODIFY THIS CODE!!! ***/
  for(;;){}
  /*** Processor Expert end of main routine. DON'T WRITE CODE BELOW!!! ***/
} /*** End of main routine. DO NOT MODIFY THIS TEXT!!! ***/

/* END main */
/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.3 [05.09]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
